Kea: isc::dhcp::SubnetConfigParser Class Reference

| Kea 1.5.0

Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
isc::dhcp::SubnetConfigParser Class Referenceabstract

this class parses a single subnet More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::SubnetConfigParser:
[legend]

## Public Member Functions
| SubnetConfigParser (uint16_t family)
| constructor More...
virtual | ~SubnetConfigParser ()
| virtual destructor (does nothing) More...
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t. More...
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t. More...
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value. More...

## Protected Member Functions
virtual void | initSubnet (isc::data::ConstElementPtr params, isc::asiolink::IOAddress addr, uint8_t len)=0
| Instantiates the subnet based on a given IP prefix and prefix length. More...
SubnetPtr | parse (isc::data::ConstElementPtr subnet)
| parses a subnet description and returns Subnet{4,6} structure More...
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type , target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope. More...
template<typename int_type >
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope. More...

## Static Protected Member Functions
static Network::HRMode | hrModeFromText (const std::string &txt)
| Attempts to convert text representation to HRMode enum. More...

## Protected Attributes
uint16_t | address_family_
| Address family: `AF_INET` or `AF_INET6`. More...
CfgOptionPtr | options_
| Pointer to the options configuration. More...
PoolStoragePtr | pools_
| Storage for pools belonging to this subnet. More...
isc::dhcp::Network::RelayInfoPtr | relay_info_
| Pointer to relay information. More...
isc::dhcp::SubnetPtr | subnet_
| Pointer to the created subnet object. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child. More...
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope. More...
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope. More...
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element. More...
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope. More...
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values. More...
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list. More...

## Detailed Description

this class parses a single subnet

There are dedicated Subnet4ConfigParser and Subnet6ConfigParser classes. They provide specialized parse() methods that return Subnet4Ptr or Subnet6Ptr.

This class parses the whole subnet definition. This class attempts to unify the code between v4 and v6 as much as possible. As a result, the flow is somewhat complex and it looks as follows:

    ------- Base class

/ | /--— Derived class

1. * SubnetXConfigParser::parse() is called.
2. * SubnetConfigParser::parse() is called.
3. * SubnetConfigParser::createSubnet() is called.
4. * SubnetXConfigParser::initSubnet() is called (Subnet4 or Subnet6 is instantiated here and family specific parameters are set)
5. Control returns to createSubnet() (step 3) and common parameters are set.

Definition at line 453 of file dhcp_parsers.h.

## Constructor & Destructor Documentation

## ◆ SubnetConfigParser()

isc::dhcp::SubnetConfigParser::SubnetConfigParser | ( | uint16_t | family | ) |
| explicit

constructor

Parameters

  family | address family: `AF_INET` or `AF_INET6`

Definition at line 484 of file dhcp_parsers.cc.

References relay_info_.

## ◆ ~SubnetConfigParser()

virtual isc::dhcp::SubnetConfigParser::~SubnetConfigParser | ( |  | ) |
| inlinevirtual

virtual destructor (does nothing)

Definition at line 462 of file dhcp_parsers.h.

## Member Function Documentation

## ◆ hrModeFromText()

Network::HRMode isc::dhcp::SubnetConfigParser::hrModeFromText | ( | const std::string & | txt | ) |
| staticprotected

Attempts to convert text representation to HRMode enum.

Allowed values are "disabled", "off" (alias for disabled), "out-of-pool" and "all". See Subnet::HRMode for their exact meaning.

Parameters

  txt | Host Reservation mode in the textual form.

Exceptions

  BadValue | if the text cannot be converted.

Returns
  one of allowed HRMode values

Definition at line 519 of file dhcp_parsers.cc.

References isc::dhcp::Network::HR_ALL, isc::dhcp::Network::HR_DISABLED, isc::dhcp::Network::HR_GLOBAL, isc::dhcp::Network::HR_OUT_OF_POOL, and isc_throw.

Referenced by isc::dhcp::Subnet4ConfigParser::initSubnet(), and isc::dhcp::Subnet6ConfigParser::initSubnet().

## ◆ initSubnet()

virtual void isc::dhcp::SubnetConfigParser::initSubnet | ( | isc::data::ConstElementPtr | params,
|  | isc::asiolink::IOAddress | addr,
|  | uint8_t | len
| ) |  |
| protectedpure virtual

Instantiates the subnet based on a given IP prefix and prefix length.

Parameters

  params | configuration parameters for that subnet
  addr | is the IP prefix of the subnet.
  len | is the prefix length

Implemented in isc::dhcp::Subnet6ConfigParser, and isc::dhcp::Subnet4ConfigParser.

## ◆ parse()

SubnetPtr isc::dhcp::SubnetConfigParser::parse | ( | isc::data::ConstElementPtr | subnet | ) |
| protected

parses a subnet description and returns Subnet{4,6} structure

This method is called from specialized (Subnet4ConfigParser or Subnet6ConfigParser) classes.

Parameters

  subnet | pointer to the content of subnet definition

Returns
  a pointer to newly created subnet

Exceptions

  isc::DhcpConfigError | if subnet configuration parsing failed.

Definition at line 492 of file dhcp_parsers.cc.

References address_family_, isc_throw, options_, isc::dhcp::OptionDataListParser::parse(), isc::dhcp::RelayInfoParser::parse(), relay_info_, subnet_, isc::dhcp::Option::V4, isc::dhcp::Option::V6, and isc::Exception::what().

Referenced by isc::dhcp::Subnet4ConfigParser::parse(), and isc::dhcp::Subnet6ConfigParser::parse().

Here is the call graph for this function:

## Member Data Documentation

## ◆ address_family_

uint16_t isc::dhcp::SubnetConfigParser::address_family_
| protected

Address family: `AF_INET` or `AF_INET6`.

Definition at line 515 of file dhcp_parsers.h.

Referenced by parse().

## ◆ options_

CfgOptionPtr isc::dhcp::SubnetConfigParser::options_
| protected

Pointer to the options configuration.

Definition at line 521 of file dhcp_parsers.h.

Referenced by isc::dhcp::Subnet4ConfigParser::initSubnet(), isc::dhcp::Subnet6ConfigParser::initSubnet(), and parse().

## ◆ pools_

PoolStoragePtr isc::dhcp::SubnetConfigParser::pools_
| protected

Storage for pools belonging to this subnet.

Definition at line 509 of file dhcp_parsers.h.

Referenced by isc::dhcp::Subnet4ConfigParser::parse(), and isc::dhcp::Subnet6ConfigParser::parse().

## ◆ relay_info_

isc::dhcp::Network::RelayInfoPtr isc::dhcp::SubnetConfigParser::relay_info_
| protected

Pointer to relay information.

Definition at line 518 of file dhcp_parsers.h.

Referenced by parse(), isc::dhcp::Subnet4ConfigParser::parse(), isc::dhcp::Subnet6ConfigParser::parse(), and SubnetConfigParser().

## ◆ subnet_

isc::dhcp::SubnetPtr isc::dhcp::SubnetConfigParser::subnet_
| protected

Pointer to the created subnet object.

Definition at line 512 of file dhcp_parsers.h.

Referenced by isc::dhcp::Subnet4ConfigParser::initSubnet(), isc::dhcp::Subnet6ConfigParser::initSubnet(), parse(), isc::dhcp::Subnet4ConfigParser::parse(), and isc::dhcp::Subnet6ConfigParser::parse().

The documentation for this class was generated from the following files:

- dhcp_parsers.h
- dhcp_parsers.cc